<?php
/**
 * Copyright © 2015 FiloBlu. All rights reserved.
 */

namespace FiloBlu\Flow\Helper;

use \Monolog\Handler\StreamHandler;

/**
 * Class LoggerProvider
 * @package FiloBlu\Flow\Helper
 */
class LoggerProvider
{

    /**
     * @var Monolog\Logger
     */
    protected $_logger;

    /**
     * LoggerProvider constructor.
     * @param \Magento\Framework\Filesystem $filesystem
     * @param string $filename
     * @throws \Exception
     */
    public function __construct(
        \Magento\Framework\Filesystem $filesystem,
        $filename = 'mod2-flow'
    ) {
        $channelName = 'flow-channel';
        $this->_logger = new \Monolog\Logger($channelName);
        $vardir = $filesystem
            ->getDirectoryRead(\Magento\Framework\App\Filesystem\DirectoryList::VAR_DIR)
            ->getAbsolutePath();

        $this->_logger->pushHandler(new StreamHandler(
            $vardir . 'log' . DIRECTORY_SEPARATOR . basename($filename) . '.log'
        ));
    }

    /**
     * @return Monolog\Logger|\Monolog\Logger
     */
    public function getLogger()
    {
        return $this->_logger;
    }

}